package jp.co.example.rssreader;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

import org.apache.http.impl.cookie.DateParseException;
import org.apache.http.impl.cookie.DateUtils;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.TextView;

public class ListAdapter extends ArrayAdapter<Item> {
	private LayoutInflater mInflater;

	static class ViewHolder {  
		TextView mTitle;
		TextView mPubdate;
		TextView mDescr;
		ImageView image;
		ProgressBar progress;
	}  
	
	public ListAdapter(Context context, List<Item> objects) {
		super(context, 0, objects);
		mInflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	}
	
	@Override
	public View getView(int position, View convertView, ViewGroup parent) {  
	    ViewHolder holder;  
	      
	    // r[󂯎  
	    View view = convertView;  
	    if (view == null) {  
	        // 󂯎r[nullȂVr[𐶐  
	        view = mInflater.inflate(R.layout.item, null);
	        TextView mTitle = (TextView)view.findViewById(R.id.item_title);  
	        TextView mPubdate = (TextView)view.findViewById(R.id.item_pubdate);
	        TextView mDescr = (TextView)view.findViewById(R.id.item_descr);  
	        ImageView imageView = (ImageView)view.findViewById(R.id.item_enclosure);
	        ProgressBar progress = (ProgressBar)view.findViewById(R.id.progress);
	        
	        holder = new ViewHolder();  
	        holder.mTitle = mTitle;  
	        holder.mPubdate = mPubdate;  
	        holder.mDescr = mDescr;  
	        holder.image = imageView;
	        holder.progress = progress;
	        view.setTag(holder);  
	    } else {  
	        holder = (ViewHolder)view.getTag();  
	    }
	    
	    // \ׂf[^̎擾  
	    Item item = this.getItem(position);
	    
		// ItempubDate擾ătH[}bg
		String pubdate = item.getPubdate().toString();
		String pattern[] = { DateUtils.PATTERN_RFC1123 };
		String formattedPubdate = "";
		try {
		Date date = DateUtils.parseDate(pubdate, pattern);
		SimpleDateFormat sdf = new SimpleDateFormat("MMM d, yyyy 'at' HH:mm");
		formattedPubdate = sdf.format(date);
		} catch (DateParseException e) {
		e.printStackTrace();
		}

	    holder.mTitle.setText(item.getTitle().toString());  
	    holder.mPubdate.setText(formattedPubdate);  
	    holder.mDescr.setText(item.getDescription().toString());
	    
	    holder.progress.setVisibility(View.VISIBLE);
	    holder.image.setVisibility(View.GONE);

	    String imageUrl = item.getEnclosure().toString();  
	    holder.image.setTag(imageUrl);
	    DownloadTask task = new DownloadTask(holder.image, holder.progress);  
        task.execute(imageUrl);  
        
	    return view;  
	}
}
