package jp.co.example.rssreader;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

import android.app.ProgressDialog;
import android.os.AsyncTask;
import android.util.Xml;

public class ParserTask extends AsyncTask<String, Integer, ListAdapter> {
	private RSSReaderActivity mActivity;
	private ListAdapter mAdapter;
	private ProgressDialog mProgressDialog;

	// RXgN^
	public ParserTask(RSSReaderActivity activity, ListAdapter adapter) {
		mActivity = activity;
		mAdapter = adapter;
	}

	// ^XNsꂽɌĂяo
	@Override
	protected void onPreExecute() {
		mProgressDialog = new ProgressDialog(mActivity);
		mProgressDialog.setMessage("Now Loading...");
		mProgressDialog.show();
	}

	// obNOEh
	@Override
	protected ListAdapter doInBackground(String... params) {
		ListAdapter result = null;
		try {
			URL url = new URL(params[0]);
			InputStream is = url.openConnection().getInputStream();
			result = parseXml(is);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return result;
	}

	// CXbh
	@Override
	protected void onPostExecute(ListAdapter result) {
		mProgressDialog.dismiss();
		mActivity.setListAdapter(result);
	}

	// XMLp[X
	public ListAdapter parseXml(InputStream is) throws IOException, XmlPullParserException {
		XmlPullParser parser = Xml.newPullParser();
		try {
			parser.setInput(is, null);
			int eventType = parser.getEventType();
			Item currentItem = null;
			while (eventType != XmlPullParser.END_DOCUMENT) {
				String tag = null;
				switch (eventType) {
					case XmlPullParser.START_TAG:
						tag = parser.getName();
						if (tag.equals("item")) {
							currentItem = new Item();
						} else if (currentItem != null) {
							if (tag.equalsIgnoreCase("title")) {
								currentItem.setTitle(parser.nextText());
							} else if (tag.equalsIgnoreCase("description")) {
								currentItem.setDescription(parser.nextText());
							} else if (tag.equalsIgnoreCase("pubDate")) {
								currentItem.setPubdate(parser.nextText());
							} else if (tag.equalsIgnoreCase("link")) {
								currentItem.setLink(parser.getAttributeValue(3));
							} else if (tag.equalsIgnoreCase("enclosure")) {
								currentItem.setEnclosure(parser.getAttributeValue(0));
							}
						}
						break;
					case XmlPullParser.END_TAG:
						tag = parser.getName();
						if (tag.equals("item")) {
							mAdapter.add(currentItem);
						}
						break;
				}
				eventType = parser.next();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return mAdapter;
	}
}