package jp.co.example.rssreader;

import java.util.ArrayList;

import jp.co.nobot.libAdMaker.AdMakerListener;
import jp.co.nobot.libAdMaker.libAdMaker;

import com.adwhirl.AdWhirlLayout;
import com.adwhirl.AdWhirlLayout.AdWhirlInterface;
import com.adwhirl.util.AdWhirlUtil;

import com.google.android.apps.analytics.GoogleAnalyticsTracker;

import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.Toast;

public class RSSReaderActivity extends ListActivity implements AdMakerListener, AdWhirlInterface {
	public static final int MENU_ITEM_RELOAD = Menu.FIRST;
	public static final String RSS_FEED_URL = "http://tomonari.co.uk/feed/";
	private ArrayList<Item> mItems;
	private ListAdapter mAdapter;
	GoogleAnalyticsTracker tracker;
	AdWhirlLayout adWhirlLayout;
	private libAdMaker AdMaker = null;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		
		tracker = GoogleAnalyticsTracker.getInstance();
	    tracker.startNewSession("UA-00000000-0", 20, this);
	    tracker.trackPageView("/AppTopList");
		
		mItems = new ArrayList<Item>();
		mAdapter = new ListAdapter(this, mItems);
		
		if(checkInternet(this.getApplicationContext())) {
			ParserTask task = new ParserTask(this, mAdapter);
			task.execute(RSS_FEED_URL);
		} else {
			Toast.makeText(this, "lbg[NɐڑĂ܂", Toast.LENGTH_LONG).show();
		}
		
		//AdWhirl
        LinearLayout layout = (LinearLayout)findViewById(R.id.layout_ad);
        adWhirlLayout = new AdWhirlLayout(this, "ADWHIRL_KEY");
        adWhirlLayout.setAdWhirlInterface(this);
    	RelativeLayout.LayoutParams adWhirlLayoutParams = new RelativeLayout.LayoutParams(480, 75);
    	layout.addView(adWhirlLayout, adWhirlLayoutParams);
    	
    	//AdMaker
    	AdMaker = new libAdMaker(this);
    	AdMaker.setAdMakerListener(this);
    	AdMaker.siteId = "siteId";
    	AdMaker.zoneId = "siteId";
    	AdMaker.setUrl("siteUrl");
	}
	
	// Xg̍ڂȈ
	@Override
	protected void onListItemClick(ListView l, View v, int position, long id) {
		Item item = mItems.get(position);
		tracker.trackEvent("List", "Item", "Clicked", position);
		tracker.setCustomVar(1, "Link", item.getLink().toString());
		Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse(item.getLink().toString()));
		startActivity(intent);
	}
	
	// MENU{^Ƃ̏
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		boolean result = super.onCreateOptionsMenu(menu);
		menu.add(0, MENU_ITEM_RELOAD, 0, "XV");
		return result;
	}
	
	// MENU̍ڂIƂ̏
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
			case MENU_ITEM_RELOAD:
				mItems = new ArrayList<Item>();
				mAdapter = new ListAdapter(this, mItems);
				if(checkInternet(this.getApplicationContext())){
					ParserTask task = new ParserTask(this, mAdapter);
					task.execute(RSS_FEED_URL);
				} else {
					Toast.makeText(this, "lbg[NɐڑĂ܂", Toast.LENGTH_LONG).show();
				}
				return true;
		}
		return super.onOptionsItemSelected(item);
	}
	
	public static boolean checkInternet(Context context){
        ConnectivityManager cm = (ConnectivityManager)context.getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo ni = cm.getActiveNetworkInfo();
        if( ni != null ){
            return cm.getActiveNetworkInfo().isConnected();
        }
        return false;
	}
	
	@Override
	public void adWhirlGeneric() {
		Log.e(AdWhirlUtil.ADWHIRL, "In adWhirlGeneric()");
	}
    
    //AdMaker
    public void performEventAdMaker() {
    	AdMaker.start();
    	RelativeLayout.LayoutParams AdMakerLayoutParams = new RelativeLayout.LayoutParams(480, 75);
    	adWhirlLayout.addView(AdMaker, AdMakerLayoutParams);
    }
    
	//AdMaker̃Cxg̏Ԃ擾
    @Override
	public void onFailedToReceiveAdMaker(String error) {
    	Log.v("AdMaker", "L擾o܂ł");
	}

	@Override
	public void onReceiveAdMaker() {
		Log.v("AdMaker", "L擾܂");
	}
    
	//AvIƂ
    @Override
    public void onDestroy() {
    	super.onDestroy();
    	tracker.stopSession();
    	if(AdMaker != null) {
    		AdMaker.destroy();
    		AdMaker = null;
    	}
    }

    //̃AvɑJڂƂ
	@Override
	protected void onPause () {
		super.onPause();
		if(AdMaker != null) {
			AdMaker.stop();
		}
	}

	//ēxAv𗧂グƂ
	@Override
	protected void onRestart () {
		super.onRestart();
		if(AdMaker != null) {
			AdMaker.start();
		}
	}
}