//
//  RootViewController.m
//  AdAnalytics
//
//  Created by Tomonari Shimada on 00/00/00.
//  Copyright 2011 Blueair Inc. All rights reserved.
//

#import "RootViewController.h"

@implementation RootViewController

@synthesize _tableView;

#pragma mark -
#pragma mark Initialization

// ビューがロードされたら呼ばれる
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // タイトル
    self.title = @"AdAnalytics";
    
    // テーブルに表示するリスト
    itemList = [[NSArray alloc] initWithObjects:@"Apple", @"Google", @"Yahoo!", @"Microsoft", @"Facebook", @"アップル", @"グーグル", @"ヤフー", @"マイクロソフト", @"フェイスブック", nil];
}

// ビューが表示される前に呼ばれる
- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

#pragma mark -
#pragma mark Device orientation

// デバイスの回転に対応するか設定
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return YES;
}

#pragma mark -
#pragma mark UITableViewDelegate methods

// セクションの数
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

// 項目の数
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [itemList count];
}

// セルの表示
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [_tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    
    // テーブルのセルにリストの項目を表示
    cell.textLabel.text = [itemList objectAtIndex:indexPath.row];
    
    return cell;
}

// セルが選択されたときに呼ばれる
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSError *error;
    if (![[GANTracker sharedTracker] setCustomVariableAtIndex:1
                                                         name:@"Link"
                                                        value:[itemList objectAtIndex:indexPath.row] 
                                                    withError:&error]) {
    }
    
    if (![[GANTracker sharedTracker] trackEvent:@"List"
                                         action:@"Item"
                                          label:@"Clicked"
                                          value:indexPath.row
                                      withError:&error]) {
    }
}

#pragma mark -
#pragma mark Memory management

// メモリ警告のとき呼ばれる
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

// ビューがアンロードしたら呼ばれる
- (void)viewDidUnload
{
    [super viewDidUnload];
}

// メモリ解放処理
- (void)dealloc
{
    [_tableView release], _tableView = nil;
    [itemList release], itemList = nil;
    [super dealloc];
}

@end
