//
//  Items.m
//  RSSReader
//
//  Created by Tomonari Shimada on 00/00/00.
//  Copyright 2011 Blueair Inc. All rights reserved.
//

#import "Items.h"

static Items *sharedItemsInstance = nil;

@implementation Items

- init {
	if (self = [super init]) {
		list = [[NSMutableArray alloc] init];
	}
	return self;
}

+ (Items *)sharedItems{
	@synchronized(self) {
		if(sharedItemsInstance == nil) {
			[[self alloc] init];
		}
	}
	return sharedItemsInstance;
}

+ (id)allocWithZone:(NSZone *)zone {
    @synchronized(self) {
        if (sharedItemsInstance == nil) {
            sharedItemsInstance = [super allocWithZone:zone];
            return sharedItemsInstance;
        }
    }
    return nil;
}

- (void)addToItems:(Item *)newItem{
	[list addObject: newItem];
}

- (Item *)getItem:(NSInteger)index{
	return [list objectAtIndex:index];
}

- (void)clearItems{
	[list removeAllObjects];
}

- (NSInteger)getItemsCount{
	return [list count];
}

@end
