//
//  Parser.m
//  RSSReader
//
//  Created by Tomonari Shimada on 00/00/00.
//  Copyright 2011 Blueair Inc. All rights reserved.
//

#import "Parser.h"
#import "Items.h"
#import "Item.h"

@implementation Parser

- (void)parseXMLFileAtURL:(NSURL *)URL
{
    NSXMLParser *parser = [[NSXMLParser alloc] initWithContentsOfURL:URL];
    [parser setDelegate:self];
    [parser parse];
    [parser release];
}

- (void)parserDidStartDocument:(NSXMLParser *)parser
{
    [UIApplication sharedApplication].networkActivityIndicatorVisible = YES;
}

- (void)parserDidEndDocument:(NSXMLParser *)parser
{
    [UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
}

- (void)parser:(NSXMLParser *)parser parseErrorOccurred:(NSError *)parseError {
	NSLog(@"Parse error code %i", [parseError code]);
}

- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName attributes:(NSDictionary *)attributeDict
{   
    if ([elementName isEqualToString:@"item"]) {
		itemObject = [[Item alloc] init];
		[[Items sharedItems] addToItems:itemObject];
        itemFlag = TRUE;
	}
    if (itemFlag) {
        if ([elementName isEqualToString:@"title"]) {
            currentStringValue = [NSMutableString string];
        } else if ([elementName isEqualToString:@"link"]) {
            currentStringValue = [NSMutableString string];
        } else if ([elementName isEqualToString:@"description"]) {
            currentStringValue = [NSMutableString string];
        } else if ([elementName isEqualToString:@"pubDate"]) {
            currentStringValue = [NSMutableString string];
        } else if ([elementName isEqualToString:@"enclosure"]) {
            currentStringValue = [attributeDict objectForKey:@"url"];
        } else {
            currentStringValue = nil;
        }
    }
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
    if (itemFlag) {
        if ([elementName isEqualToString:@"title"]) {
            itemObject.titleString = currentStringValue;
        } else if ([elementName isEqualToString:@"link"]) {
            itemObject.linkString = currentStringValue;
        } else if ([elementName isEqualToString:@"description"]) {
            itemObject.descriptionString = currentStringValue;
        } else if ([elementName isEqualToString:@"pubDate"]) {
            itemObject.pubDateString = currentStringValue;
        } else if ([elementName isEqualToString:@"enclosure"]) {
            itemObject.enclosureString = currentStringValue;
        }
        currentStringValue = nil;
    }
    if ([elementName isEqualToString:@"item"]) {
        itemFlag = FALSE;
	}
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
    if(currentStringValue) {
		[currentStringValue appendString:string];
	}
}

@end
